#include "io430.h"
#include <stdbool.h>
#include "speaker.h"

struct Note
{
  Pitch pitch;
  unsigned char duration;
};
typedef struct Note Note;

Note musik[] =
{
  {a, 1},
  {fis, 1},
  {d, 2},
  {pause, 1},
  {g, 1},
  {e, 1},
  {c, 2}
};

const unsigned int durationUnitInMilliseconds = 200;

void callback(void);

int main(void)
{
  initialize(callback);

  while(true)
  {}
  
  // return 0;
}

void callback(void)
{
  static long callCount = -1;
  callCount++;
    
  static int currentEvent = -1;
  
  static unsigned int callCountAtEndOfCurrentEvent = 0;
  
  if(callCount == callCountAtEndOfCurrentEvent)
  {
    currentEvent++;
    unsigned int length = sizeof musik / sizeof (Note);
    if(currentEvent >= length)
    {
      outputSound(false);
    }
    else
    {
      callCountAtEndOfCurrentEvent += durationUnitInMilliseconds * musik[currentEvent].duration / 30;
      if(musik[currentEvent].pitch == pause)
      {
        outputSound(false);
      }
      else
      {
        outputSound(true);
        setPitch(musik[currentEvent].pitch);
      }
    }
  }
}